"use strict";

var through = require("through2"),
    script = require("cirru-script"),
    gutil = require("gulp-util"),
    parser = require("cirru-parser"),
    escodegen = require("escodegen"),
    scirpus = require("scirpus");

var replaceExtension = gutil.replaceExtension;

module.exports = function (opts) {
  return through.obj(function (file, encoding, callback) {
    var contents = String(file.contents);

    if (opts && opts.es6) {
      var syntaxTree = parser.pare(contents);
      var ast = scirpus.transform(syntaxTree);
      var js = escodegen.generate(ast);
    } else {
      var js = script.compile(contents);
    }

    file.contents = new Buffer(js);
    file.path = replaceExtension(file.path, ".js");
    return callback(null, file);
  });
};